#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;

const int N = 1 << 20;
int a[42];
ll f[42][N | 1];
int main()
{
    **f = 1;
    int T, n, m;
    scanf("%d", &T);
    for (int t = 1; t <= T; t++)
    {
        scanf("%d%d", &n, &m);
        for (int i = 1; i <= n; i++)
            scanf("%d", a + i);
        for (int i = 1; i <= n; i++)
            for (int j = 0; j < N; j++)
                f[i][j] = f[i - 1][j ^ a[i]] + f[i - 1][j];
        printf("Case #%d: %lld\n", t, accumulate(f[n] + m, f[n] + N, 0ll));
    }
    return 0;
}